> For the complete documentation index, see [llms.txt](https://docs.os.uk/os-apis/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.os.uk/os-apis/accessing-os-apis/os-features-api/technical-specification.md).

# Technical specification

This technical specification explains the content of the OS Features API and the methods you can use to call it.

The OS Features API lets users call and interact with OS data, including the highly detailed OS MasterMap Topography Layer. It does this by exposing the data through an Open Geospatial Consortium Web Feature Service (OGC WFS).

{% hint style="info" %}
If you are not familiar with the OS Features API, please read the [overview documentation ](/os-apis/accessing-os-apis/os-features-api.md)before proceeding.
{% endhint %}

## Core concepts

This specification does not cover core concepts that apply to all Ordnance Survey APIs.

Please read the following pages to learn more about OS API core concepts:

* [Authentication](/os-apis/core-concepts/authentication.md)
* [Error codes](/os-apis/core-concepts/error-codes.md)
* [Rate-limiting policy](/os-apis/core-concepts/rate-limiting-policy.md)

## API reference

The OS Features API exposes data through an Open Geospatial Consortium Web Feature Service (OGC WFS).

The OGC WFS accepts three types of requests:

<table data-view="cards"><thead><tr><th></th><th></th><th data-hidden data-card-target data-type="content-ref"></th></tr></thead><tbody><tr><td><strong>getCapabilities</strong></td><td>Returns a metadata describing the WFS service .</td><td><a href="/pages/wHGVWfWV5SCnNadmajwl">/pages/wHGVWfWV5SCnNadmajwl</a></td></tr><tr><td><strong>describeFeatureType</strong></td><td>Returns a description of the attributes for each feature type.</td><td><a href="/pages/IEHMMdlfDVaitSvFEK1h">/pages/IEHMMdlfDVaitSvFEK1h</a></td></tr><tr><td><strong>getFeature</strong></td><td>Returns a selection of a specific features including its attribute values and geometry.</td><td><a href="/pages/KGyKd0u3j2n6fAOAKbNW">/pages/KGyKd0u3j2n6fAOAKbNW</a></td></tr></tbody></table>


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.os.uk/os-apis/accessing-os-apis/os-features-api/technical-specification.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
